<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FileTxnLog.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.persistence</a> &gt; <span class="el_source">FileTxnLog.java</span></div><h1>FileTxnLog.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server.persistence;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.zip.Adler32;
import java.util.zip.Checksum;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.txn.TxnHeader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class implements the TxnLog interface. It provides api's
 * to access the txnlogs and add entries to it.
 * &lt;p&gt;
 * The format of a Transactional log is as follows:
 * &lt;blockquote&gt;&lt;pre&gt;
 * LogFile:
 *     FileHeader TxnList ZeroPad
 * 
 * FileHeader: {
 *     magic 4bytes (ZKLG)
 *     version 4bytes
 *     dbid 8bytes
 *   }
 * 
 * TxnList:
 *     Txn || Txn TxnList
 *     
 * Txn:
 *     checksum Txnlen TxnHeader Record 0x42
 * 
 * checksum: 8bytes Adler32 is currently used
 *   calculated across payload -- Txnlen, TxnHeader, Record and 0x42
 * 
 * Txnlen:
 *     len 4bytes
 * 
 * TxnHeader: {
 *     sessionid 8bytes
 *     cxid 4bytes
 *     zxid 8bytes
 *     time 8bytes
 *     type 4bytes
 *   }
 *     
 * Record:
 *     See Jute definition file for details on the various record types
 *      
 * ZeroPad:
 *     0 padded to EOF (filled during preallocation stage)
 * &lt;/pre&gt;&lt;/blockquote&gt; 
 */
public class FileTxnLog implements TxnLog {
    private static final Logger LOG;

<span class="fc" id="L93">    static long preAllocSize =  65536 * 1024;</span>

<span class="fc" id="L95">    public final static int TXNLOG_MAGIC =</span>
<span class="fc" id="L96">        ByteBuffer.wrap(&quot;ZKLG&quot;.getBytes()).getInt();</span>

    public final static int VERSION = 2;

    /** Maximum time we allow for elapsed fsync before WARNing */
    private final static long fsyncWarningThresholdMS;

    static {
<span class="fc" id="L104">        LOG = LoggerFactory.getLogger(FileTxnLog.class);</span>

<span class="fc" id="L106">        String size = System.getProperty(&quot;zookeeper.preAllocSize&quot;);</span>
<span class="fc bfc" id="L107" title="All 2 branches covered.">        if (size != null) {</span>
            try {
<span class="fc" id="L109">                preAllocSize = Long.parseLong(size) * 1024;</span>
<span class="nc" id="L110">            } catch (NumberFormatException e) {</span>
<span class="nc" id="L111">                LOG.warn(size + &quot; is not a valid value for preAllocSize&quot;);</span>
<span class="fc" id="L112">            }</span>
        }
<span class="fc" id="L114">        fsyncWarningThresholdMS = Long.getLong(&quot;fsync.warningthresholdms&quot;, 1000);</span>
<span class="fc" id="L115">    }</span>

    long lastZxidSeen;
<span class="fc" id="L118">    volatile BufferedOutputStream logStream = null;</span>
    volatile OutputArchive oa;
<span class="fc" id="L120">    volatile FileOutputStream fos = null;</span>

    File logDir;
<span class="fc bfc" id="L123" title="All 2 branches covered.">    private final boolean forceSync = !System.getProperty(&quot;zookeeper.forceSync&quot;, &quot;yes&quot;).equals(&quot;no&quot;);;</span>
    long dbId;
<span class="fc" id="L125">    private LinkedList&lt;FileOutputStream&gt; streamsToFlush =</span>
        new LinkedList&lt;FileOutputStream&gt;();
    long currentSize;
<span class="fc" id="L128">    File logFileWrite = null;</span>

    /**
     * constructor for FileTxnLog. Take the directory
     * where the txnlogs are stored
     * @param logDir the directory where the txnlogs are stored
     */
<span class="fc" id="L135">    public FileTxnLog(File logDir) {</span>
<span class="fc" id="L136">        this.logDir = logDir;</span>
<span class="fc" id="L137">    }</span>

    /**
     * method to allow setting preallocate size
     * of log file to pad the file.
     * @param size the size to set to in bytes
     */
    public static void setPreallocSize(long size) {
<span class="fc" id="L145">        preAllocSize = size;</span>
<span class="fc" id="L146">    }</span>

    /**
     * creates a checksum alogrithm to be used
     * @return the checksum used for this txnlog
     */
    protected Checksum makeChecksumAlgorithm(){
<span class="fc" id="L153">        return new Adler32();</span>
    }


    /**
     * rollover the current log file to a new one.
     * @throws IOException
     */
    public synchronized void rollLog() throws IOException {
<span class="pc bpc" id="L162" title="1 of 2 branches missed.">        if (logStream != null) {</span>
<span class="fc" id="L163">            this.logStream.flush();</span>
<span class="fc" id="L164">            this.logStream = null;</span>
<span class="fc" id="L165">            oa = null;</span>
        }
<span class="fc" id="L167">    }</span>

    /**
     * close all the open file handles
     * @throws IOException
     */
    public synchronized void close() throws IOException {
<span class="fc bfc" id="L174" title="All 2 branches covered.">        if (logStream != null) {</span>
<span class="fc" id="L175">            logStream.close();</span>
        }
<span class="fc bfc" id="L177" title="All 2 branches covered.">        for (FileOutputStream log : streamsToFlush) {</span>
<span class="fc" id="L178">            log.close();</span>
<span class="fc" id="L179">        }</span>
<span class="fc" id="L180">    }</span>
    
    /**
     * append an entry to the transaction log
     * @param hdr the header of the transaction
     * @param txn the transaction part of the entry
     * returns true iff something appended, otw false 
     */
    public synchronized boolean append(TxnHeader hdr, Record txn)
        throws IOException
    {
<span class="fc bfc" id="L191" title="All 2 branches covered.">        if (hdr != null) {</span>
<span class="pc bpc" id="L192" title="1 of 2 branches missed.">            if (hdr.getZxid() &lt;= lastZxidSeen) {</span>
<span class="nc" id="L193">                LOG.warn(&quot;Current zxid &quot; + hdr.getZxid()</span>
                        + &quot; is &lt;= &quot; + lastZxidSeen + &quot; for &quot;
<span class="nc" id="L195">                        + hdr.getType());</span>
            }
<span class="fc bfc" id="L197" title="All 2 branches covered.">            if (logStream==null) {</span>
<span class="pc bpc" id="L198" title="1 of 2 branches missed.">               if(LOG.isInfoEnabled()){</span>
<span class="fc" id="L199">                    LOG.info(&quot;Creating new log file: log.&quot; +  </span>
<span class="fc" id="L200">                            Long.toHexString(hdr.getZxid()));</span>
               }
               
<span class="fc" id="L203">               logFileWrite = new File(logDir, (&quot;log.&quot; + </span>
<span class="fc" id="L204">                       Long.toHexString(hdr.getZxid())));</span>
<span class="fc" id="L205">               fos = new FileOutputStream(logFileWrite);</span>
<span class="fc" id="L206">               logStream=new BufferedOutputStream(fos);</span>
<span class="fc" id="L207">               oa = BinaryOutputArchive.getArchive(logStream);</span>
<span class="fc" id="L208">               FileHeader fhdr = new FileHeader(TXNLOG_MAGIC,VERSION, dbId);</span>
<span class="fc" id="L209">               fhdr.serialize(oa, &quot;fileheader&quot;);</span>
               // Make sure that the magic number is written before padding.
<span class="fc" id="L211">               logStream.flush();</span>
<span class="fc" id="L212">               currentSize = fos.getChannel().position();</span>
<span class="fc" id="L213">               streamsToFlush.add(fos);</span>
            }
<span class="fc" id="L215">            padFile(fos);</span>
<span class="fc" id="L216">            byte[] buf = Util.marshallTxnEntry(hdr, txn);</span>
<span class="pc bpc" id="L217" title="2 of 4 branches missed.">            if (buf == null || buf.length == 0) {</span>
<span class="nc" id="L218">                throw new IOException(&quot;Faulty serialization for header &quot; +</span>
                        &quot;and txn&quot;);
            }
<span class="fc" id="L221">            Checksum crc = makeChecksumAlgorithm();</span>
<span class="fc" id="L222">            crc.update(buf, 0, buf.length);</span>
<span class="fc" id="L223">            oa.writeLong(crc.getValue(), &quot;txnEntryCRC&quot;);</span>
<span class="fc" id="L224">            Util.writeTxnBytes(oa, buf);</span>
            
<span class="fc" id="L226">            return true;</span>
        }
<span class="fc" id="L228">        return false;</span>
    }

    /**
     * pad the current file to increase its size
     * @param out the outputstream to be padded
     * @throws IOException
     */
    private void padFile(FileOutputStream out) throws IOException {
<span class="fc" id="L237">        currentSize = Util.padLogFile(out, currentSize, preAllocSize);</span>
<span class="fc" id="L238">    }</span>

    /**
     * Find the log file that starts at, or just before, the snapshot. Return
     * this and all subsequent logs. Results are ordered by zxid of file,
     * ascending order.
     * @param logDirList array of files
     * @param snapshotZxid return files at, or before this zxid
     * @return
     */
    public static File[] getLogFiles(File[] logDirList,long snapshotZxid) {
<span class="fc" id="L249">        List&lt;File&gt; files = Util.sortDataDir(logDirList, &quot;log&quot;, true);</span>
<span class="fc" id="L250">        long logZxid = 0;</span>
        // Find the log file that starts before or at the same time as the
        // zxid of the snapshot
<span class="fc bfc" id="L253" title="All 2 branches covered.">        for (File f : files) {</span>
<span class="fc" id="L254">            long fzxid = Util.getZxidFromName(f.getName(), &quot;log&quot;);</span>
<span class="fc bfc" id="L255" title="All 2 branches covered.">            if (fzxid &gt; snapshotZxid) {</span>
<span class="fc" id="L256">                continue;</span>
            }
            // the files
            // are sorted with zxid's
<span class="fc bfc" id="L260" title="All 2 branches covered.">            if (fzxid &gt; logZxid) {</span>
<span class="fc" id="L261">                logZxid = fzxid;</span>
            }
<span class="fc" id="L263">        }</span>
<span class="fc" id="L264">        List&lt;File&gt; v=new ArrayList&lt;File&gt;(5);</span>
<span class="fc bfc" id="L265" title="All 2 branches covered.">        for (File f : files) {</span>
<span class="fc" id="L266">            long fzxid = Util.getZxidFromName(f.getName(), &quot;log&quot;);</span>
<span class="fc bfc" id="L267" title="All 2 branches covered.">            if (fzxid &lt; logZxid) {</span>
<span class="fc" id="L268">                continue;</span>
            }
<span class="fc" id="L270">            v.add(f);</span>
<span class="fc" id="L271">        }</span>
<span class="fc" id="L272">        return v.toArray(new File[0]);</span>

    }

    /**
     * get the last zxid that was logged in the transaction logs
     * @return the last zxid logged in the transaction logs
     */
    public long getLastLoggedZxid() {
<span class="nc" id="L281">        File[] files = getLogFiles(logDir.listFiles(), 0);</span>
<span class="nc bnc" id="L282" title="All 2 branches missed.">        long maxLog=files.length&gt;0?</span>
<span class="nc" id="L283">                Util.getZxidFromName(files[files.length-1].getName(),&quot;log&quot;):-1;</span>

        // if a log file is more recent we must scan it to find
        // the highest zxid
<span class="nc" id="L287">        long zxid = maxLog;</span>
<span class="nc" id="L288">        TxnIterator itr = null;</span>
        try {
<span class="nc" id="L290">            FileTxnLog txn = new FileTxnLog(logDir);</span>
<span class="nc" id="L291">            itr = txn.read(maxLog);</span>
            while (true) {
<span class="nc bnc" id="L293" title="All 2 branches missed.">                if(!itr.next())</span>
<span class="nc" id="L294">                    break;</span>
<span class="nc" id="L295">                TxnHeader hdr = itr.getHeader();</span>
<span class="nc" id="L296">                zxid = hdr.getZxid();</span>
<span class="nc" id="L297">            }</span>
<span class="nc" id="L298">        } catch (IOException e) {</span>
<span class="nc" id="L299">            LOG.warn(&quot;Unexpected exception&quot;, e);</span>
<span class="nc" id="L300">        } finally {</span>
<span class="nc" id="L301">            close(itr);</span>
<span class="nc" id="L302">        }</span>
<span class="nc" id="L303">        return zxid;</span>
    }

    private void close(TxnIterator itr) {
<span class="pc bpc" id="L307" title="1 of 2 branches missed.">        if (itr != null) {</span>
            try {
<span class="fc" id="L309">                itr.close();</span>
<span class="nc" id="L310">            } catch (IOException ioe) {</span>
<span class="nc" id="L311">                LOG.warn(&quot;Error closing file iterator&quot;, ioe);</span>
<span class="fc" id="L312">            }</span>
        }
<span class="fc" id="L314">    }</span>

    /**
     * commit the logs. make sure that evertyhing hits the
     * disk
     */
    public synchronized void commit() throws IOException {
<span class="fc bfc" id="L321" title="All 2 branches covered.">        if (logStream != null) {</span>
<span class="fc" id="L322">            logStream.flush();</span>
        }
<span class="fc bfc" id="L324" title="All 2 branches covered.">        for (FileOutputStream log : streamsToFlush) {</span>
<span class="fc" id="L325">            log.flush();</span>
<span class="pc bpc" id="L326" title="1 of 2 branches missed.">            if (forceSync) {</span>
<span class="fc" id="L327">                long startSyncNS = System.nanoTime();</span>

<span class="fc" id="L329">                log.getChannel().force(false);</span>

<span class="fc" id="L331">                long syncElapsedMS =</span>
<span class="fc" id="L332">                    TimeUnit.NANOSECONDS.toMillis(System.nanoTime() - startSyncNS);</span>
<span class="pc bpc" id="L333" title="1 of 2 branches missed.">                if (syncElapsedMS &gt; fsyncWarningThresholdMS) {</span>
<span class="nc" id="L334">                    LOG.warn(&quot;fsync-ing the write ahead log in &quot;</span>
<span class="nc" id="L335">                            + Thread.currentThread().getName()</span>
                            + &quot; took &quot; + syncElapsedMS
                            + &quot;ms which will adversely effect operation latency. &quot;
                            + &quot;See the ZooKeeper troubleshooting guide&quot;);
                }
            }
<span class="fc" id="L341">        }</span>
<span class="fc bfc" id="L342" title="All 2 branches covered.">        while (streamsToFlush.size() &gt; 1) {</span>
<span class="fc" id="L343">            streamsToFlush.removeFirst().close();</span>
        }
<span class="fc" id="L345">    }</span>

    /**
     * start reading all the transactions from the given zxid
     * @param zxid the zxid to start reading transactions from
     * @return returns an iterator to iterate through the transaction
     * logs
     */
    public TxnIterator read(long zxid) throws IOException {
<span class="fc" id="L354">        return new FileTxnIterator(logDir, zxid);</span>
    }

    /**
     * truncate the current transaction logs
     * @param zxid the zxid to truncate the logs to
     * @return true if successful false if not
     */
    public boolean truncate(long zxid) throws IOException {
<span class="fc" id="L363">        FileTxnIterator itr = null;</span>
        try {
<span class="fc" id="L365">            itr = new FileTxnIterator(this.logDir, zxid);</span>
<span class="fc" id="L366">            PositionInputStream input = itr.inputStream;</span>
<span class="fc bfc" id="L367" title="All 2 branches covered.">            if(input == null) {</span>
<span class="fc" id="L368">                throw new IOException(&quot;No log files found to truncate! This could &quot; +</span>
                        &quot;happen if you still have snapshots from an old setup or &quot; +
                        &quot;log files were deleted accidentally or dataLogDir was changed in zoo.cfg.&quot;);
            }
<span class="fc" id="L372">            long pos = input.getPosition();</span>
            // now, truncate at the current position
<span class="fc" id="L374">            RandomAccessFile raf = new RandomAccessFile(itr.logFile, &quot;rw&quot;);</span>
<span class="fc" id="L375">            raf.setLength(pos);</span>
<span class="fc" id="L376">            raf.close();</span>
<span class="pc bpc" id="L377" title="1 of 2 branches missed.">            while (itr.goToNextLog()) {</span>
<span class="nc bnc" id="L378" title="All 2 branches missed.">                if (!itr.logFile.delete()) {</span>
<span class="nc" id="L379">                    LOG.warn(&quot;Unable to truncate {}&quot;, itr.logFile);</span>
                }
            }
<span class="fc" id="L382">        } finally {</span>
<span class="fc" id="L383">            close(itr);</span>
<span class="fc" id="L384">        }</span>
<span class="fc" id="L385">        return true;</span>
    }

    /**
     * read the header of the transaction file
     * @param file the transaction file to read
     * @return header that was read fomr the file
     * @throws IOException
     */
    private static FileHeader readHeader(File file) throws IOException {
<span class="nc" id="L395">        InputStream is =null;</span>
        try {
<span class="nc" id="L397">            is = new BufferedInputStream(new FileInputStream(file));</span>
<span class="nc" id="L398">            InputArchive ia=BinaryInputArchive.getArchive(is);</span>
<span class="nc" id="L399">            FileHeader hdr = new FileHeader();</span>
<span class="nc" id="L400">            hdr.deserialize(ia, &quot;fileheader&quot;);</span>
<span class="nc" id="L401">            return hdr;</span>
         } finally {
<span class="nc" id="L403">             try {</span>
<span class="nc bnc" id="L404" title="All 4 branches missed.">                 if (is != null) is.close();</span>
<span class="nc" id="L405">             } catch (IOException e) {</span>
<span class="nc" id="L406">                 LOG.warn(&quot;Ignoring exception during close&quot;, e);</span>
<span class="nc" id="L407">             }</span>
         }
    }

    /**
     * the dbid of this transaction database
     * @return the dbid of this database
     */
    public long getDbId() throws IOException {
<span class="nc" id="L416">        FileTxnIterator itr = new FileTxnIterator(logDir, 0);</span>
<span class="nc" id="L417">        FileHeader fh=readHeader(itr.logFile);</span>
<span class="nc" id="L418">        itr.close();</span>
<span class="nc bnc" id="L419" title="All 2 branches missed.">        if(fh==null)</span>
<span class="nc" id="L420">            throw new IOException(&quot;Unsupported Format.&quot;);</span>
<span class="nc" id="L421">        return fh.getDbid();</span>
    }

    /**
     * the forceSync value. true if forceSync is enabled, false otherwise.
     * @return the forceSync value
     */
    public boolean isForceSync() {
<span class="fc" id="L429">        return forceSync;</span>
    }

    /**
     * a class that keeps track of the position 
     * in the input stream. The position points to offset
     * that has been consumed by the applications. It can 
     * wrap buffered input streams to provide the right offset 
     * for the application.
     */
    static class PositionInputStream extends FilterInputStream {
        long position;
        protected PositionInputStream(InputStream in) {
<span class="fc" id="L442">            super(in);</span>
<span class="fc" id="L443">            position = 0;</span>
<span class="fc" id="L444">        }</span>
        
        @Override
        public int read() throws IOException {
<span class="fc" id="L448">            int rc = super.read();</span>
<span class="pc bpc" id="L449" title="1 of 2 branches missed.">            if (rc &gt; -1) {</span>
<span class="fc" id="L450">                position++;</span>
            }
<span class="fc" id="L452">            return rc;</span>
        }

        public int read(byte[] b) throws IOException {
<span class="nc" id="L456">            int rc = super.read(b);</span>
<span class="nc bnc" id="L457" title="All 2 branches missed.">            if (rc &gt; 0) {</span>
<span class="nc" id="L458">                position += rc;</span>
            }
<span class="nc" id="L460">            return rc;            </span>
        }
        
        @Override
        public int read(byte[] b, int off, int len) throws IOException {
<span class="fc" id="L465">            int rc = super.read(b, off, len);</span>
<span class="fc bfc" id="L466" title="All 2 branches covered.">            if (rc &gt; 0) {</span>
<span class="fc" id="L467">                position += rc;</span>
            }
<span class="fc" id="L469">            return rc;</span>
        }
        
        @Override
        public long skip(long n) throws IOException {
<span class="nc" id="L474">            long rc = super.skip(n);</span>
<span class="nc bnc" id="L475" title="All 2 branches missed.">            if (rc &gt; 0) {</span>
<span class="nc" id="L476">                position += rc;</span>
            }
<span class="nc" id="L478">            return rc;</span>
        }
        public long getPosition() {
<span class="fc" id="L481">            return position;</span>
        }

        @Override
        public boolean markSupported() {
<span class="nc" id="L486">            return false;</span>
        }

        @Override
        public void mark(int readLimit) {
<span class="nc" id="L491">            throw new UnsupportedOperationException(&quot;mark&quot;);</span>
        }

        @Override
        public void reset() {
<span class="nc" id="L496">            throw new UnsupportedOperationException(&quot;reset&quot;);</span>
        }
    }
    
    /**
     * this class implements the txnlog iterator interface
     * which is used for reading the transaction logs
     */
    public static class FileTxnIterator implements TxnLog.TxnIterator {
        File logDir;
        long zxid;
        TxnHeader hdr;
        Record record;
        File logFile;
        InputArchive ia;
        static final String CRC_ERROR=&quot;CRC check failed&quot;;
       
<span class="fc" id="L513">        PositionInputStream inputStream=null;</span>
        //stored files is the list of files greater than
        //the zxid we are looking for.
        private ArrayList&lt;File&gt; storedFiles;

        /**
         * create an iterator over a transaction database directory
         * @param logDir the transaction database directory
         * @param zxid the zxid to start reading from
         * @throws IOException
         */
<span class="fc" id="L524">        public FileTxnIterator(File logDir, long zxid) throws IOException {</span>
<span class="fc" id="L525">          this.logDir = logDir;</span>
<span class="fc" id="L526">          this.zxid = zxid;</span>
<span class="fc" id="L527">          init();</span>
<span class="fc" id="L528">        }</span>

        /**
         * initialize to the zxid specified
         * this is inclusive of the zxid
         * @throws IOException
         */
        void init() throws IOException {
<span class="fc" id="L536">            storedFiles = new ArrayList&lt;File&gt;();</span>
<span class="fc" id="L537">            List&lt;File&gt; files = Util.sortDataDir(FileTxnLog.getLogFiles(logDir.listFiles(), 0), &quot;log&quot;, false);</span>
<span class="fc bfc" id="L538" title="All 2 branches covered.">            for (File f: files) {</span>
<span class="fc bfc" id="L539" title="All 2 branches covered.">                if (Util.getZxidFromName(f.getName(), &quot;log&quot;) &gt;= zxid) {</span>
<span class="fc" id="L540">                    storedFiles.add(f);</span>
                }
                // add the last logfile that is less than the zxid
<span class="pc bpc" id="L543" title="1 of 2 branches missed.">                else if (Util.getZxidFromName(f.getName(), &quot;log&quot;) &lt; zxid) {</span>
<span class="fc" id="L544">                    storedFiles.add(f);</span>
<span class="fc" id="L545">                    break;</span>
                }
<span class="fc" id="L547">            }</span>
<span class="fc" id="L548">            goToNextLog();</span>
<span class="fc bfc" id="L549" title="All 2 branches covered.">            if (!next())</span>
<span class="fc" id="L550">                return;</span>
<span class="fc bfc" id="L551" title="All 2 branches covered.">            while (hdr.getZxid() &lt; zxid) {</span>
<span class="fc bfc" id="L552" title="All 2 branches covered.">                if (!next())</span>
<span class="fc" id="L553">                    return;</span>
            }
<span class="fc" id="L555">        }</span>

        /**
         * go to the next logfile
         * @return true if there is one and false if there is no
         * new file to be read
         * @throws IOException
         */
        private boolean goToNextLog() throws IOException {
<span class="fc bfc" id="L564" title="All 2 branches covered.">            if (storedFiles.size() &gt; 0) {</span>
<span class="fc" id="L565">                this.logFile = storedFiles.remove(storedFiles.size()-1);</span>
<span class="fc" id="L566">                ia = createInputArchive(this.logFile);</span>
<span class="fc" id="L567">                return true;</span>
            }
<span class="fc" id="L569">            return false;</span>
        }

        /**
         * read the header from the inputarchive
         * @param ia the inputarchive to be read from
         * @param is the inputstream
         * @throws IOException
         */
        protected void inStreamCreated(InputArchive ia, InputStream is)
            throws IOException{
<span class="fc" id="L580">            FileHeader header= new FileHeader();</span>
<span class="fc" id="L581">            header.deserialize(ia, &quot;fileheader&quot;);</span>
<span class="pc bpc" id="L582" title="1 of 2 branches missed.">            if (header.getMagic() != FileTxnLog.TXNLOG_MAGIC) {</span>
<span class="nc" id="L583">                throw new IOException(&quot;Transaction log: &quot; + this.logFile + &quot; has invalid magic number &quot; </span>
<span class="nc" id="L584">                        + header.getMagic()</span>
                        + &quot; != &quot; + FileTxnLog.TXNLOG_MAGIC);
            }
<span class="fc" id="L587">        }</span>

        /**
         * Invoked to indicate that the input stream has been created.
         * @param ia input archive
         * @param is file input stream associated with the input archive.
         * @throws IOException
         **/
        protected InputArchive createInputArchive(File logFile) throws IOException {
<span class="pc bpc" id="L596" title="1 of 2 branches missed.">            if(inputStream==null){</span>
<span class="fc" id="L597">                inputStream= new PositionInputStream(new BufferedInputStream(new FileInputStream(logFile)));</span>
<span class="fc" id="L598">                LOG.debug(&quot;Created new input stream &quot; + logFile);</span>
<span class="fc" id="L599">                ia  = BinaryInputArchive.getArchive(inputStream);</span>
<span class="fc" id="L600">                inStreamCreated(ia,inputStream);</span>
<span class="fc" id="L601">                LOG.debug(&quot;Created new input archive &quot; + logFile);</span>
            }
<span class="fc" id="L603">            return ia;</span>
        }

        /**
         * create a checksum algorithm
         * @return the checksum algorithm
         */
        protected Checksum makeChecksumAlgorithm(){
<span class="fc" id="L611">            return new Adler32();</span>
        }

        /**
         * the iterator that moves to the next transaction
         * @return true if there is more transactions to be read
         * false if not.
         */
        public boolean next() throws IOException {
<span class="fc bfc" id="L620" title="All 2 branches covered.">            if (ia == null) {</span>
<span class="fc" id="L621">                return false;</span>
            }
            try {
<span class="fc" id="L624">                long crcValue = ia.readLong(&quot;crcvalue&quot;);</span>
<span class="fc" id="L625">                byte[] bytes = Util.readTxnBytes(ia);</span>
                // Since we preallocate, we define EOF to be an
<span class="pc bpc" id="L627" title="1 of 4 branches missed.">                if (bytes == null || bytes.length==0) {</span>
<span class="fc" id="L628">                    throw new EOFException(&quot;Failed to read &quot; + logFile);</span>
                }
                // EOF or corrupted record
                // validate CRC
<span class="fc" id="L632">                Checksum crc = makeChecksumAlgorithm();</span>
<span class="fc" id="L633">                crc.update(bytes, 0, bytes.length);</span>
<span class="pc bpc" id="L634" title="1 of 2 branches missed.">                if (crcValue != crc.getValue())</span>
<span class="nc" id="L635">                    throw new IOException(CRC_ERROR);</span>
<span class="pc bpc" id="L636" title="2 of 4 branches missed.">                if (bytes == null || bytes.length == 0)</span>
<span class="nc" id="L637">                    return false;</span>
<span class="fc" id="L638">                hdr = new TxnHeader();</span>
<span class="fc" id="L639">                record = SerializeUtils.deserializeTxn(bytes, hdr);</span>
<span class="fc" id="L640">            } catch (EOFException e) {</span>
<span class="fc" id="L641">                LOG.debug(&quot;EOF excepton &quot; + e);</span>
<span class="fc" id="L642">                inputStream.close();</span>
<span class="fc" id="L643">                inputStream = null;</span>
<span class="fc" id="L644">                ia = null;</span>
<span class="fc" id="L645">                hdr = null;</span>
                // this means that the file has ended
                // we should go to the next file
<span class="fc bfc" id="L648" title="All 2 branches covered.">                if (!goToNextLog()) {</span>
<span class="fc" id="L649">                    return false;</span>
                }
                // if we went to the next log file, we should call next() again
<span class="fc" id="L652">                return next();</span>
<span class="fc" id="L653">            } catch (IOException e) {</span>
<span class="fc" id="L654">                inputStream.close();</span>
<span class="fc" id="L655">                throw e;</span>
<span class="fc" id="L656">            }</span>
<span class="fc" id="L657">            return true;</span>
        }

        /**
         * reutrn the current header
         * @return the current header that
         * is read
         */
        public TxnHeader getHeader() {
<span class="fc" id="L666">            return hdr;</span>
        }

        /**
         * return the current transaction
         * @return the current transaction
         * that is read
         */
        public Record getTxn() {
<span class="fc" id="L675">            return record;</span>
        }

        /**
         * close the iterator
         * and release the resources.
         */
        public void close() throws IOException {
<span class="fc bfc" id="L683" title="All 2 branches covered.">            if (inputStream != null) {</span>
<span class="fc" id="L684">                inputStream.close();</span>
            }
<span class="fc" id="L686">        }</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>